package com.kingdee.eas.custom.projectbonus.app;

import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.eas.basedata.org.AdminOrgUnitInfo;
import com.kingdee.eas.custom.projectbonus.*;
import com.kingdee.eas.custom.projectbonus.bizEnum.BusDepProjectStateEnum;
import com.kingdee.eas.hr.org.JobGradeInfo;
import com.kingdee.shr.base.syssetting.BaseItemException;
import com.kingdee.util.DateTimeUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.log4j.Logger;
import com.kingdee.bos.*;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.eas.common.EASBizException;

import java.lang.String;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Date;

public class BonusCycleBusDepProjectControllerBean extends AbstractBonusCycleBusDepProjectControllerBean {
    private static Logger logger =
            Logger.getLogger(BonusCycleBusDepProjectControllerBean.class);
    //ѯ
    private final static SelectorItemCollection sic = new SelectorItemCollection();
    //
    private final static SelectorItemCollection updateSic = new SelectorItemCollection();

    static {
        sic.add("state");
        sic.add("project.name");
        sic.add("busDep.name");
        updateSic.add("state");
    }


    /**
     * 
     *
     * @param ctx
     * @param billId id
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _enable(Context ctx,
                           String billId) throws BOSException, EASBizException {
        //super._enable(ctx, billId);
        if (StringUtils.isEmpty(billId)) {
            logger.error("idΪգ");
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"idΪգ"});
        }
        BonusCycleBusDepProjectInfo info = getBonusCycleBusDepProjectInfo(ctx, new ObjectUuidPK(billId), sic);
        BusDepProjectStateEnum state = info.getState();
        if (BusDepProjectStateEnum.INITIALIZATION.equals(state) || BusDepProjectStateEnum.DISABLE.equals(state)) {
            //״̬ڳʼ  
            info.setState(BusDepProjectStateEnum.ENABLE);
            try {
                updatePartial(ctx, info, updateSic);
            } catch (Exception e) {
                e.printStackTrace();
                throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{e.getMessage()});
            }
        } else if (BusDepProjectStateEnum.SUBMITED.equals(state)) {
            //״̬ύ
            StringBuilder errorMsg = new StringBuilder();
            errorMsg.append(getBusDepMsg(info));
            errorMsg.append("ύִò");
            logger.error(errorMsg.toString());
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{errorMsg.toString()});
        }
    }

    /**
     * 
     *
     * @param ctx
     * @param billId id
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _disable(Context ctx,
                            String billId) throws BOSException, EASBizException {
        if (StringUtils.isEmpty(billId)) {
            logger.error("idΪգ");
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"idΪգ"});
        }
        BonusCycleBusDepProjectInfo info = getBonusCycleBusDepProjectInfo(ctx, new ObjectUuidPK(billId));
        BusDepProjectStateEnum state = info.getState();
        if (!BusDepProjectStateEnum.DISABLE.equals(state)) {
            info.setState(BusDepProjectStateEnum.DISABLE);
            try {
                updatePartial(ctx, info, updateSic);
            } catch (Exception e) {
                e.printStackTrace();
                logger.error(e.getMessage());
                throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{e.getMessage()});
            }
        }
    }

    /**
     * ύ
     *
     * @param ctx
     * @param billId
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _submit(Context ctx, String billId) throws BOSException, EASBizException {
        if (StringUtils.isEmpty(billId)) {
            logger.error("idΪգ");
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"idΪգ"});
        }
        BonusCycleBusDepProjectInfo info = getBonusCycleBusDepProjectInfo(ctx, new ObjectUuidPK(billId), sic);
        BusDepProjectStateEnum state = info.getState();
        String alias = state.getAlias();
        if (BusDepProjectStateEnum.ENABLE.equals(state)) {
            //״̬
            info.setState(BusDepProjectStateEnum.SUBMITED);
            try {
                //
                calculate(ctx, billId);
                updatePartial(ctx, info, updateSic);
            } catch (Exception e) {
                e.printStackTrace();
                throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{e.getMessage()});
            }
        } else if (BusDepProjectStateEnum.DISABLE.equals(state)
                || BusDepProjectStateEnum.INITIALIZATION.equals(state)) {
            //״̬ڽ  ʼ
            StringBuilder errorMsg = new StringBuilder();
            errorMsg.append(getBusDepMsg(info));
            errorMsg.append("").append(alias).append("ִύ");
            logger.error(errorMsg.toString());
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{errorMsg.toString()});
        }
    }

    /**
     * 
     *
     * @param ctx
     * @param billId
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _withdraw(Context ctx, String billId) throws BOSException, EASBizException {
        if (StringUtils.isEmpty(billId)) {
            logger.error("idΪգ");
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"idΪգ"});
        }
        BonusCycleBusDepProjectInfo info = getBonusCycleBusDepProjectInfo(ctx, new ObjectUuidPK(billId), sic);
        BusDepProjectStateEnum state = info.getState();
        String alias = state.getAlias();
        if (BusDepProjectStateEnum.SUBMITED.equals(state)) {
            //״̬
            info.setState(BusDepProjectStateEnum.ENABLE);
            try {
                updatePartial(ctx, info, updateSic);
            } catch (Exception e) {
                e.printStackTrace();
                throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{e.getMessage()});
            }
        } else if (BusDepProjectStateEnum.DISABLE.equals(state)
                || BusDepProjectStateEnum.INITIALIZATION.equals(state)) {
            //״̬ڽ  ʼ
            StringBuilder errorMsg = new StringBuilder();
            errorMsg.append(getBusDepMsg(info));
            errorMsg.append("").append(alias).append("ִύ");
            logger.error(errorMsg.toString());
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{errorMsg.toString()});
        }
    }

    /**
     * ˽
     *
     * @param ctx
     * @param billId
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _calculate(Context ctx, String billId) throws BOSException, EASBizException {
        if (StringUtils.isEmpty(billId)) {
            logger.error("idΪգ");
            throw new BOSException("idΪգ");
        }
        SelectorItemCollection depSic = new SelectorItemCollection();
        depSic.add("*");
        depSic.add("project.name");
        depSic.add("busDep.name");
        depSic.add("AssPersonnelDetail.person.name");
        depSic.add("AssPersonnelDetail.grade.coefficient");
        depSic.add("AssPersonnelDetail.*");
        SelectorItemCollection updateDetailSic = new SelectorItemCollection();
        updateDetailSic.add("attendanceRate");
        updateDetailSic.add("assessmentCoeff");
        updateDetailSic.add("cumulative");
        updateDetailSic.add("bonusProportion");
        updateDetailSic.add("indivBonusAmount");
        //ҵĿ
        BonusCycleBusDepProjectInfo info = (BonusCycleBusDepProjectInfo) getValue(ctx, new ObjectUuidPK(billId), depSic);
        //ְ
        BigDecimal bonusAmount = info.getBonusAmount();
        if (bonusAmount == null) {
            throw new BOSException(getBusDepMsg(info) + "ĽְΪգ");
        }
        //Աϸ
        BonusCycleBusDepProjectAssPersonnelDetailCollection assPersonnelDetailCols = info.getAssPersonnelDetail();
        IBonusCycleBusDepProjectAssPersonnelDetail iBonusCycleBusDepProjectAssPersonnelDetail = BonusCycleBusDepProjectAssPersonnelDetailFactory.getLocalInstance(ctx);
        //ͬҵ£ְϵ *  * Ͷϵ * ְϵ * ˿ϵ֮
        BigDecimal cumulativeSum = BigDecimal.ZERO;
        //ʣͬҵ£ְϵ *  * Ͷϵ * ְϵ * ˿ϵ֮
        BigDecimal cumulativeSurplus = BigDecimal.ZERO;
        //ʣְཱ
        BigDecimal bonusAmountSurplus = BigDecimal.ZERO;
        for (int i = 0; i < assPersonnelDetailCols.size(); i++) {
            BonusCycleBusDepProjectAssPersonnelDetailInfo detailInfo = assPersonnelDetailCols.get(i);
            //
            String personName = detailInfo.getPerson().getName();
            //
            Date bonusStartingDate = detailInfo.getBonusStartingDate();
            if (bonusStartingDate == null) {
                throw new BOSException("Ա[" + personName + "]ĽΪգ");
            }
            //޽ֹ
            Date bonusDueDate = detailInfo.getBonusDueDate();
            if (bonusDueDate == null) {
                throw new BOSException("Ա[" + personName + "]Ľ޽ֹΪգ");
            }
            if (bonusStartingDate.compareTo(bonusDueDate) >= 0) {
                throw new BOSException("޽ֹ ڵ ");
            }
            // = (޽ֹ-)/180
            double day = DateTimeUtils.dateDiff(bonusStartingDate, bonusDueDate) / 86400000.0 / 180.0 * 100;
            if (day <= 0) {
                throw new BOSException("Ա[" + personName + "]ĳ[" + day + "]Сڵ0!");
            }
            BigDecimal attendanceRate = new BigDecimal(String.valueOf(day)).setScale(0, RoundingMode.HALF_UP);
            detailInfo.setAttendanceRate(attendanceRate);
            //Q1Чϵ
            BigDecimal performanceCoeffQ1 = detailInfo.getPerformanceCoeffQ1();
            if (performanceCoeffQ1 == null) {
                throw new BOSException("Ա[" + personName + "]Q1ЧϵΪգ");
            }
            //Q2Чϵ
            BigDecimal performanceCoeffQ2 = detailInfo.getPerformanceCoeffQ1();
            if (performanceCoeffQ2 == null) {
                throw new BOSException("Ա[" + personName + "]Q2ЧϵΪգ");
            }
            //˿ϵ
            BigDecimal assessmentCoeff = performanceCoeffQ1.add(performanceCoeffQ2).divide(BigDecimal.valueOf(2)).setScale(2, RoundingMode.HALF_UP);
            detailInfo.setAssessmentCoeff(assessmentCoeff);
            //ְϵ
            BigDecimal functionCoefficient = detailInfo.getFunctionCoefficient();
            if (functionCoefficient == null) {
                throw new BOSException("Ա[" + personName + "]ְϵΪգ");
            }
            //Ͷϵ
            BigDecimal energyInputCoeff = detailInfo.getEnergyInputCoeff();
            if (energyInputCoeff == null) {
                throw new BOSException("Ա[" + personName + "]ľͶϵΪգ");
            }
            //ְϵ
            JobGradeInfo grade = detailInfo.getGrade();
            if (grade == null) {
                throw new BOSException("Ա[" + personName + "]ְΪգ");
            }
            BigDecimal rankCoefficient = grade.getBigDecimal("coefficient");
            if (rankCoefficient == null) {
                throw new BOSException("Ա[" + personName + "]ְϵΪգ");
            }
            //ְϵ * Ͷϵ *  * ְϵ * ˿ϵ
            BigDecimal cumulative = functionCoefficient.multiply(energyInputCoeff)
                    .multiply(attendanceRate).multiply(rankCoefficient).multiply(assessmentCoeff).divide(new BigDecimal(100), 2, RoundingMode.HALF_UP);
            detailInfo.setCumulative(cumulative);
            cumulativeSum = cumulativeSum.add(cumulative);
            //˳ʼ
            BigDecimal initialProportion = detailInfo.getInitialProportion();
            if (initialProportion == null) {
                throw new BOSException("Ա[" + personName + "]ĸ˳ʼΪգ");
            }
            if (initialProportion.compareTo(BigDecimal.ZERO) < 0 || initialProportion.compareTo(BigDecimal.ONE) > 0) {
                throw new BOSException("˳ʼֻ[0,1]֮");
            }
        }
        if (cumulativeSum.compareTo(BigDecimal.ZERO) == 0) {
            throw new BOSException(getBusDepMsg(info) + "(ְϵ * Ͷϵ *  * ְϵ * ˿ϵ)ܺͲΪ0");
        }

        //˽
        for (int i = 0; i < assPersonnelDetailCols.size(); i++) {
            BonusCycleBusDepProjectAssPersonnelDetailInfo detailInfo = assPersonnelDetailCols.get(i);
            //ְϵ *  * Ͷϵ * ְϵ * ˿ϵ
            BigDecimal cumulative = detailInfo.getCumulative();
            //˽ռ = ݣְϵ *  * Ͷϵ * ְϵ * ˿ϵ/ ͬҵ£ְϵ *  * Ͷϵ * ְϵ * ˿ϵ֮ͼó
            BigDecimal bonusProportion = BigDecimal.ZERO;
            if (i == (assPersonnelDetailCols.size() - 1)) {
                //һβ
                bonusProportion = BigDecimal.ONE.subtract(cumulativeSurplus);
            } else {
                bonusProportion = cumulative.divide(cumulativeSum, 2, RoundingMode.HALF_UP);
                cumulativeSurplus = cumulativeSurplus.add(bonusProportion);
            }
            detailInfo.setBonusProportion(bonusProportion);
            //˳ʼ
            BigDecimal initialProportion = detailInfo.getInitialProportion();
            BigDecimal indivBonusAmount = BigDecimal.ZERO;
            if (i == (assPersonnelDetailCols.size() - 1)) {
                //һβ
                indivBonusAmount = bonusAmount.subtract(bonusAmountSurplus).multiply(initialProportion);
            } else {
                //ڸ˽ = ְ *  ˽ռ * ˳ʼ
                BigDecimal indivBonusAmountTemp = bonusAmount.multiply(bonusProportion);
                bonusAmountSurplus = bonusAmountSurplus.add(indivBonusAmountTemp);
                indivBonusAmount = indivBonusAmountTemp.multiply(initialProportion);
            }
            detailInfo.setIndivBonusAmount(indivBonusAmount);
            //
            iBonusCycleBusDepProjectAssPersonnelDetail.updatePartial(detailInfo, updateDetailSic);
        }
    }

    private String getBusDepMsg(BonusCycleBusDepProjectInfo info) {
        AdminOrgUnitInfo project = info.getProject();
        if (project != null) {
            String projectProject = project.getName();
            return "Ŀ[" + projectProject + "]";
        } else {
            String busdepName = info.getBusDep().getName();
            return "ҵ[" + busdepName + "]";
        }
    }
}