package com.kingdee.eas.custom.projectbonus.web.handler;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemCollection;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.orgunitEx.ProjectType;
import com.kingdee.eas.custom.projectbonus.*;
import com.kingdee.eas.custom.projectbonus.bizEnum.BusDepProjectStateEnum;
import com.kingdee.eas.custom.projectbonus.web.vo.*;
import com.kingdee.eas.framework.ICoreBase;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.json.GridDataEntity;
import com.kingdee.shr.base.syssetting.web.handler.DynamicListHandler;
import com.kingdee.shr.base.syssetting.web.json.JSONUtils;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.math.BigDecimal;
import java.sql.SQLException;
import java.util.*;

/**
 * @Description ڱ̬бhandler
 * @Date 2024/4/22 17:56
 * @Created by Heyuan
 */
public class BusDepProjectDynamicListHandler extends DynamicListHandler {
    private static Logger logger = Logger.getLogger(BusDepProjectDynamicListHandler.class);

    /**
     * ȡЧڹ
     * Ƴ෽
     *
     * @param effectDate
     * @return
     */
    protected FilterInfo getEffectDateFilter(Date effectDate) {
        return null;
    }

    /**
     * @param request
     * @param response
     * @param gridDataEntity
     * @throws SHRWebException
     */
    protected void afterGetListData(HttpServletRequest request,
                                    HttpServletResponse response,
                                    GridDataEntity gridDataEntity) throws SHRWebException {
        super.afterGetListData(request, response, gridDataEntity);
        List<Map<String, Object>> rows = gridDataEntity.getRows();
        //װF7
        for (int i = 0; i < rows.size(); i++) {
            Map<String, Object> map = rows.get(i);
            Map<String, Object> project = new HashMap<String, Object>();
            Object obj = map.get("principal.id");
            if (obj != null && !StringUtils.isEmpty(obj.toString())) {
                project.put("id", obj.toString());
                project.put("name", map.get("principal.name"));
            }
            //
            map.put("principal.name", project);
        }
    }

    /**
     * ȡĬϱ༭
     *
     * @param request
     * @return
     */
    protected Map<String, Map<String, Object>> getDefultEditColumnsSetting(HttpServletRequest request) {
        try {
            //F7༭
            Map<String, Map<String, Object>> result = new HashMap();
            EditColumnInfo editColumnInfo = new EditColumnInfo();
            editColumnInfo.setName("principal.name");
            EditOptions editoptions = editColumnInfo.getEditoptions();
            F7Json f7Json = editoptions.getF7Json();
            SubWidgetOptions subWidgetOptions = f7Json.getSubWidgetOptions();
            subWidgetOptions.setUipk("com.kingdee.eas.custom.projectbonus.app.BonusCycle.Person.F7");
            subWidgetOptions.setTitle("");
            subWidgetOptions.setQuery("com.kingdee.eas.hr.emp.app.PersonWebListQuery");
            result.put("principal.name", editColumnInfo.convertToMap());
            //״̬ö
//            EditColumnInfo stateEditColumn = new EditColumnInfo();
//            stateEditColumn.setName("bDP.state");
//            stateEditColumn.setFormatter("shrselect");
//            stateEditColumn.setEdittype("shrselect");
//            stateEditColumn.setType("shrselect");
//            EditOptions stateEditoptions = stateEditColumn.getEditoptions();
//            stateEditoptions.setUrlSource("com.kingdee.shr.base.syssetting.StateEnum");
//            SelectJson selectJson = stateEditoptions.getSelectJson();
//            selectJson.setId("setState");//
//            selectJson.setName("state");//
//            selectJson.setEnumSource("com.kingdee.shr.base.syssetting.StateEnum");
//            result.put("bDP.state", stateEditColumn.convertToMap());
            return result;
        } catch (Exception e) {
            e.printStackTrace();
            logger.error(e.getMessage());
            throw new RuntimeException(e.getMessage());
        }
    }

    /**
     * ̬
     *
     * @param request
     * @param response
     * @param modelMap
     * @return
     * @throws SHRWebException
     */
    public void saveDynGridAction(HttpServletRequest request,
                                  HttpServletResponse response,
                                  ModelMap modelMap) throws SHRWebException {
        Context ctx = SHRContext.getInstance().getContext();
        List<Map<String, Object>> dataList = (List) JSONUtils.convertJsonToObject(request.getParameter("modi"), List.class);
        try {
            IBonusCycleBusDepProject iBonusCycleBusDepProject = BonusCycleBusDepProjectFactory.getLocalInstance(ctx);
            //ݼ
            Map<String, BonusCycleBusDepProjectInfo> updateCols = new HashMap<String, BonusCycleBusDepProjectInfo>();
            //ֶ
            Map<String, SelectorItemCollection> updateSics = new HashMap<String, SelectorItemCollection>();
            for (int i = 0; i < dataList.size(); i++) {
                Map<String, Object> map = dataList.get(i);
                String idxValue = (String) map.get("fid");
                BonusCycleBusDepProjectInfo info;
                SelectorItemCollection updateSic;
                if (updateCols.containsKey(idxValue)) {
                    info = updateCols.get(idxValue);
                } else {
                    info = new BonusCycleBusDepProjectInfo();
                    info.setId(BOSUuid.read(idxValue));
                    updateCols.put(idxValue, info);
                }
                //
                if (updateSics.containsKey(idxValue)) {
                    updateSic = updateSics.get(idxValue);
                } else {
                    updateSic = new SelectorItemCollection();
                    updateSics.put(idxValue, updateSic);
                }
                //
                String colName = (String) map.get("column");
                //
                String dataType = (String) map.get("type");
                //ֵ
                Object valueObj = map.get("value");
                if ("BigDecimal".equals(dataType) && StringUtils.isEmpty(valueObj.toString())) {
                    valueObj = BigDecimal.ZERO;
                }
                updateSic.add(colName);
                info.put(colName, valueObj);
            }
            for (String id : updateCols.keySet()) {
                BonusCycleBusDepProjectInfo info = updateCols.get(id);
                SelectorItemCollection updateSic = updateSics.get(id);
                //
                iBonusCycleBusDepProject.updatePartial(info, updateSic);
            }
            JSONUtils.SUCCESS("ɹ޸" + dataList.size() + "");
        } catch (Exception var27) {
            var27.printStackTrace();
            logger.error(var27.getMessage());
            throw new ShrWebBizException(var27.getMessage(), var27);
        }
    }

    /**
     * ͬҵĿ
     *
     * @param request
     * @param response
     * @param modelMap
     * @throws SHRWebException
     */
    public void syncDepProjectAction(HttpServletRequest request,
                                     HttpServletResponse response,
                                     ModelMap modelMap) throws SHRWebException {
        String parentId = request.getParameter("parentId");//id
        if (StringUtils.isEmpty(parentId)) {
            logger.error("idΪ!");
            throw new ShrWebBizException("idΪ!");
        }
        logger.info("syncDepProjectAction_parentId: " + parentId);
        Context ctx = SHRContext.getInstance().getContext();
        String querySql = "SELECT" +
                "   fid," +
                "   CFProjectType1," +
                "   FParentID" +
                " FROM" +
                "   t_org_admin" +
                " where" +
                "   CFProjectType1 in ('1', '2', '3', '4', '5')" +
                "   and fid not in (" +
                "       SELECT" +
                "           case" +
                "               when CFProjectID is null then CFBusDepID" +
                "               else CFProjectID" +
                "           end depId" +
                "       FROM" +
                "       CT_PB_BonusCycleBusDepProject" +
                "       where fparentId = ?) and FIsOUSealUp = 0";
        logger.info("syncDepProjectAction_querySql: " + querySql);
        try {
            IRowSet iRowSet = DbUtil.executeQuery(ctx, querySql, new Object[]{parentId});
            int addCount = 0;
            IBonusCycleBusDepProject iBonusCycleBusDepProject = BonusCycleBusDepProjectFactory.getLocalInstance(ctx);
            while (iRowSet.next()) {
                String fid = iRowSet.getString("fid");//֯id
                String projectType = iRowSet.getString("CFProjectType1");
                String orgParentId = iRowSet.getString("FParentID");//֯id
                BonusCycleBusDepProjectInfo info = new BonusCycleBusDepProjectInfo();
                //
                FilterInfo filterInfo = new FilterInfo();
                FilterItemCollection filterItems = filterInfo.getFilterItems();
                filterItems.add(new FilterItemInfo("parent", parentId));
                info.put("parent", parentId);
                if ("1".equals(projectType)) {
                    info.put("busDep", fid);
                    filterItems.add(new FilterItemInfo("busDep", fid));
                } else {
                    info.put("busDep", orgParentId);
                    info.put("project", fid);
                    filterItems.add(new FilterItemInfo("busDep", orgParentId));
                    filterItems.add(new FilterItemInfo("project", fid));
                }
                info.setType(ProjectType.getEnum(projectType).getAlias());
                info.setState(BusDepProjectStateEnum.INITIALIZATION);
                if (!iBonusCycleBusDepProject.exists(filterInfo)) {
                    try {
                        iBonusCycleBusDepProject.save(info);
                        addCount++;
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }
            logger.info("" + addCount + "ҵĿ");
            JSONUtils.SUCCESS("" + addCount + "ҵĿ");
        } catch (BOSException e) {
            e.printStackTrace();
            throw new ShrWebBizException(e);
        } catch (SQLException e) {
            e.printStackTrace();
            throw new ShrWebBizException(e);
        } catch (EASBizException e) {
            e.printStackTrace();
            throw new ShrWebBizException(e);
        }
    }

    /**
     * ȡӿ
     *
     * @param request
     * @return
     * @throws SHRWebException
     */
    @Override
    protected ICoreBase getBizInterface(HttpServletRequest request) throws SHRWebException {
        Context ctx = SHRContext.getInstance().getContext();
        try {
            return BonusCycleBusDepProjectFactory.getLocalInstance(ctx);
        } catch (BOSException e) {
            e.printStackTrace();
            throw new ShrWebBizException(e.getMessage());
        }
    }

    /**
     * 
     *
     * @param request
     * @param response
     * @param modelMap
     * @throws SHRWebException
     */
    public void batchWithdrawAction(HttpServletRequest request,
                                    HttpServletResponse response,
                                    ModelMap modelMap) throws SHRWebException {
        this.handleEnableWithTips(request, "withdraw");
    }

    /**
     * 
     *
     * @param request
     * @param response
     * @param modelMap
     * @throws SHRWebException
     */
    public void lockAction(HttpServletRequest request,
                           HttpServletResponse response,
                           ModelMap modelMap) throws SHRWebException {
        Context ctx = SHRContext.getInstance().getContext();
        try {
            String parentId = request.getParameter("parentId");
            BonusCycleFactory.getLocalInstance(ctx).lock(parentId);
        } catch (Exception e) {
            e.printStackTrace();
            throw new ShrWebBizException(e.getMessage());
        }
    }

    /**
     * 
     *
     * @param request
     * @param response
     * @param modelMap
     * @throws SHRWebException
     */
    public void unlockAction(HttpServletRequest request,
                             HttpServletResponse response,
                             ModelMap modelMap) throws SHRWebException {
        Context ctx = SHRContext.getInstance().getContext();
        try {
            String parentId = request.getParameter("parentId");
            BonusCycleFactory.getLocalInstance(ctx).unLock(parentId);
        } catch (Exception e) {
            e.printStackTrace();
            throw new ShrWebBizException(e.getMessage());
        }
    }
}
