package com.kingdee.eas.custom.projectbonus.web.handler;

import com.kingdee.bos.Context;

import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.basedata.org.AdminOrgUnitInfo;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.custom.projectbonus.*;
import com.kingdee.eas.custom.projectbonus.bizEnum.BusDepProjectStateEnum;
import com.kingdee.eas.custom.projectbonus.web.vo.EditColumnInfo;
import com.kingdee.eas.custom.projectbonus.web.vo.EditOptions;
import com.kingdee.eas.custom.projectbonus.web.vo.F7Json;
import com.kingdee.eas.custom.projectbonus.web.vo.SubWidgetOptions;
import com.kingdee.eas.util.app.ContextUtil;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.json.GridDataEntity;
import com.kingdee.shr.base.syssetting.web.json.JSONUtils;
import com.kingdee.util.DateTimeUtils;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.math.BigDecimal;
import java.text.ParseException;
import java.util.*;

/**
 * @Description Աϸб̬бhandler()
 * @Date 2024/4/22 17:56
 * @Created by Heyuan
 */
public class PrincipalDetailDynamicListHandler extends PersonnelDetailDynamicListHandler {
    private static Logger logger = Logger.getLogger(PrincipalDetailDynamicListHandler.class);


    /**
     * ȡĬϱ༭
     *
     * @param request
     * @return
     */
    @Override
    protected Map<String, Map<String, Object>> getDefultEditColumnsSetting(HttpServletRequest request) {
        try {
            //F7༭
            Map<String, Map<String, Object>> result = new HashMap();
            //޽ֹ
            EditColumnInfo dateEditColumnInfo = new EditColumnInfo();
            dateEditColumnInfo.setName("bDPAPD.bonusDueDate");
            dateEditColumnInfo.setFormatter("shrDateTimePicker");
            dateEditColumnInfo.setEdittype("shrDateTimePicker");
            dateEditColumnInfo.setType("shrDateTimePicker");
            EditOptions dateEditoptions = dateEditColumnInfo.getEditoptions();
            dateEditoptions.getDatepickerjson();
            result.put("bDPAPD.bonusDueDate", dateEditColumnInfo.convertToMap());
            //
            EditColumnInfo dateEditColumnInfo2 = new EditColumnInfo();
            dateEditColumnInfo2.setName("bDPAPD.bonusStartingDate");
            dateEditColumnInfo2.setFormatter("shrDateTimePicker");
            dateEditColumnInfo2.setEdittype("shrDateTimePicker");
            dateEditColumnInfo2.setType("shrDateTimePicker");
            EditOptions dateEditoptions2 = dateEditColumnInfo2.getEditoptions();
            dateEditoptions2.getDatepickerjson();
            result.put("bDPAPD.bonusStartingDate", dateEditColumnInfo2.convertToMap());
            //Ա
            EditColumnInfo editColumnInfo = new EditColumnInfo();
            editColumnInfo.setName("person.name");
            EditOptions editoptions = editColumnInfo.getEditoptions();
            F7Json f7Json = editoptions.getF7Json();
            SubWidgetOptions subWidgetOptions = f7Json.getSubWidgetOptions();
            subWidgetOptions.setUipk("com.kingdee.eas.custom.projectbonus.app.BonusCycle.Person.F7");
            subWidgetOptions.setTitle("Ա");
            subWidgetOptions.setQuery("com.kingdee.eas.hr.emp.app.PersonWebListQuery");
            result.put("person.name", editColumnInfo.convertToMap());
            return result;
        } catch (Exception e) {
            e.printStackTrace();
            logger.error(e.getMessage());
            throw new RuntimeException(e.getMessage());
        }
    }

    /**
     * @param request
     * @param response
     * @param gridDataEntity
     * @throws SHRWebException
     */
    protected void afterGetListData(HttpServletRequest request,
                                    HttpServletResponse response,
                                    GridDataEntity gridDataEntity) throws SHRWebException {
        super.afterGetListData(request, response, gridDataEntity);
        List<Map<String, Object>> rows = gridDataEntity.getRows();
        //װF7
        for (int i = 0; i < rows.size(); i++) {
            Map<String, Object> map = rows.get(i);
            Map<String, Object> person = new HashMap<String, Object>();
            Object obj = map.get("person.id");
            if (obj != null && !StringUtils.isEmpty(obj.toString())) {
                person.put("id", obj.toString());
                person.put("name", map.get("person.name"));
            }
            //Ա
            map.put("person.name", person);
        }
    }

    /**
     * ̬
     *
     * @param request
     * @param response
     * @param modelMap
     * @return
     * @throws SHRWebException
     */
    @Override
    public void saveDynGridAction(HttpServletRequest request,
                                  HttpServletResponse response,
                                  ModelMap modelMap) throws SHRWebException {
        List<Map<String, Object>> dataList = (List) JSONUtils.convertJsonToObject(request.getParameter("modi"), List.class);
        try {
            //״̬ҵݲܱ
            IBonusCycleBusDepProjectAssPersonnelDetail iPersonnelDetail = (IBonusCycleBusDepProjectAssPersonnelDetail) getBizInterface(request);
            //ݼ
            Map<String, BonusCycleBusDepProjectAssPersonnelDetailInfo> updateCols = new HashMap<String, BonusCycleBusDepProjectAssPersonnelDetailInfo>();
            //ֶ
            Map<String, SelectorItemCollection> updateSics = new HashMap<String, SelectorItemCollection>();
            for (int i = 0; i < dataList.size(); i++) {
                Map<String, Object> map = dataList.get(i);
                String idxValue = (String) map.get("fid");
                BonusCycleBusDepProjectAssPersonnelDetailInfo info;
                SelectorItemCollection updateSic;
                if (updateCols.containsKey(idxValue)) {
                    info = updateCols.get(idxValue);
                } else {
                    info = new BonusCycleBusDepProjectAssPersonnelDetailInfo();
                    info.setId(BOSUuid.read(idxValue));
                    updateCols.put(idxValue, info);
                }
                //
                if (updateSics.containsKey(idxValue)) {
                    updateSic = updateSics.get(idxValue);
                } else {
                    updateSic = new SelectorItemCollection();
                    updateSics.put(idxValue, updateSic);
                }
                //
                String colName = (String) map.get("column");
                //
                String dataType = (String) map.get("type");
                //ֵ
                Object valueObj = map.get("value");
                if ("BigDecimal".equals(dataType) && StringUtils.isEmpty(valueObj.toString())) {
                    valueObj = BigDecimal.ZERO;
                }
                updateSic.add(colName);
                info.put(colName, valueObj);
            }
            //ɹ
            int successNum = 0;
            SelectorItemCollection sic = new SelectorItemCollection();
            sic.add("parent.state");
            for (String id : updateCols.keySet()) {
                BonusCycleBusDepProjectAssPersonnelDetailInfo oldInfo =
                        iPersonnelDetail.getBonusCycleBusDepProjectAssPersonnelDetailInfo(new ObjectUuidPK(id), sic);
                //ҵĿ
                BonusCycleBusDepProjectInfo parent = oldInfo.getParent();
                BusDepProjectStateEnum state = parent.getState();
                if (!BusDepProjectStateEnum.ENABLE.equals(state)) {
                    continue;
                }
                BonusCycleBusDepProjectAssPersonnelDetailInfo info = updateCols.get(id);
                SelectorItemCollection updateSic = updateSics.get(id);
                //
                iPersonnelDetail.updatePartial(info, updateSic);
                successNum++;
            }
            JSONUtils.SUCCESS("ɹ޸" + successNum + "");
        } catch (Exception var27) {
            var27.printStackTrace();
            logger.error(var27.getMessage());
            throw new ShrWebBizException(var27.getMessage(), var27);
        }
    }


    /**
     * ͨidȡҵid
     *
     * @param request
     * @param response
     * @param modelMap
     * @return
     * @throws SHRWebException
     */
    public void getBusDepIdStrByParentIdAction(HttpServletRequest request,
                                               HttpServletResponse response,
                                               ModelMap modelMap) throws SHRWebException {
        String parentId = request.getParameter("parentId");//id
        String type = request.getParameter("type");//
        if (StringUtils.isEmpty(parentId)) {
            throw new ShrWebBizException("idΪ!");
        }
        Context ctx = SHRContext.getInstance().getContext();
        PersonInfo personInfo = ContextUtil.getCurrentUserInfo(ctx).getPerson();
        String personId = personInfo.getId().toString();
        StringBuilder querySql = new StringBuilder();
        if ("adminOrg".equals(type)) {
            querySql.append("SELECT CFBusDepID ");
        } else {
            querySql.append("SELECT fid ");
        }
        querySql.append(" FROM CT_PB_BONUSCYCLEBUSDEPPROJECT where FParentID ='");
        querySql.append(parentId).append("' and CFState = '1'");
        querySql.append(" and CFPrincipalID ='" + personId + "'");
        JSONUtils.SUCCESS(querySql);
    }

    /**
     * ύ
     *
     * @param request
     * @param response
     * @param modelMap
     * @throws SHRWebException
     */
    public void customSubmitAction(HttpServletRequest request,
                                   HttpServletResponse response,
                                   ModelMap modelMap) throws SHRWebException {
        Context ctx = SHRContext.getInstance().getContext();
        try {
            //ҵĿids
            String busDepIds = request.getParameter("busDepIds");
            StringBuilder errorMsg = new StringBuilder();
            IBonusCycleBusDepProject iBonusCycleBusDepProject = BonusCycleBusDepProjectFactory.getLocalInstance(ctx);
            BonusCycleBusDepProjectCollection cols = iBonusCycleBusDepProject
                    .getBonusCycleBusDepProjectCollection("where id in('" + busDepIds.replace(",", "','") + "')");
            for (int i = 0; i < cols.size(); i++) {
                BonusCycleBusDepProjectInfo info = cols.get(i);
                String busDepId = info.getId().toString();
                try {
                    //ύ
                    iBonusCycleBusDepProject.submit(busDepId);
                } catch (Exception e) {
                    e.printStackTrace();
                    String type = info.getType();
                    AdminOrgUnitInfo project = info.getProject();
                    errorMsg.append(type).append("[");
                    if (project != null) {
                        String projectName = project.getName();
                        errorMsg.append(projectName).append("]");
                    } else {
                        String busDepName = info.getBusDep().getName();
                        errorMsg.append(busDepName).append("]");
                    }
                }
            }
            if (errorMsg.length() > 0) {
                errorMsg.deleteCharAt(errorMsg.length() - 1);
                errorMsg.append("ύʧ");
            }
            JSONUtils.SUCCESS(errorMsg.toString());
        } catch (Exception e) {
            e.printStackTrace();
            throw new ShrWebBizException(e.getMessage());
        }
    }

    /**
     * 
     *
     * @param request
     * @param response
     * @param modelMap
     * @throws SHRWebException
     */
    public void calculateAction(HttpServletRequest request,
                                HttpServletResponse response,
                                ModelMap modelMap) throws SHRWebException {
        Context ctx = SHRContext.getInstance().getContext();
        StringBuilder errorMsg = new StringBuilder();
        try {
            //ҵĿids
            String busDepIds = request.getParameter("busDepIds");
            IBonusCycleBusDepProject iBonusCycleBusDepProject = BonusCycleBusDepProjectFactory.getLocalInstance(ctx);
            BonusCycleBusDepProjectCollection cols = iBonusCycleBusDepProject
                    .getBonusCycleBusDepProjectCollection("where id in('" + busDepIds.replace(",", "','") + "')");
            for (int i = 0; i < cols.size(); i++) {
                BonusCycleBusDepProjectInfo info = cols.get(i);
                String busDepId = info.getId().toString();
                try {
                    //
                    iBonusCycleBusDepProject.calculate(busDepId);
                } catch (Exception e) {
                    e.printStackTrace();
                    errorMsg.append(e.getMessage()).append("  ");
                }
            }
            //JSONUtils.SUCCESS(errorMsg.toString());
        } catch (Exception e) {
            e.printStackTrace();
            throw new ShrWebBizException(e.getMessage());
        }
        if (errorMsg.length() > 0) {
            throw new ShrWebBizException(errorMsg.toString());
        }
    }
}
