package com.kingdee.eas.custom.projectbonus.web.service;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.projectbonus.*;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.base.syssetting.app.io.fileImport.BaseColumnInfo;
import com.kingdee.shr.base.syssetting.app.io.fileImport.BaseImportService;
import com.kingdee.shr.base.syssetting.app.io.fileImport.BaseRowInfo;
import com.kingdee.shr.base.syssetting.app.io.fileImport.ImportException;
import com.kingdee.shr.compensation.util.CmpSQLUtil;
import com.kingdee.shr.ml.util.SHRServerResource;
import com.kingdee.util.StringUtils;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import java.math.BigDecimal;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

/**
 * @Description ҵĿݵ
 * @Date 2024/4/29 18:04
 * @Created by Heyuan
 */
public class BonusCycleBusDepProjectImportService extends BaseImportService {
    private final static SelectorItemCollection updateSic = new SelectorItemCollection();

    static {
        updateSic.add("principal");//
        updateSic.add("notPrincipalPropor");//Ǹ˳ʼ
        updateSic.add("principalPropor");//˳ʼ
        updateSic.add("bonusAmount");//ְ
        updateSic.add("totalBonusHalf");//ϰܽ100%ھ
        updateSic.add("totalBonusReal");//ϰʵ++++ݣ
        updateSic.add("directManProjBonus");//ֱĿ
        updateSic.add("contraManProjBonus");//ίĿ
        updateSic.add("condManProjectBonus");//۹Ŀ
        updateSic.add("condManProjectBonus");//۹Ŀ
        updateSic.add("straManProjectBonus");//սĿ
        updateSic.add("bonusAdjustment");//ݽ
        updateSic.add("bonusAdjustmentDesc");//˵
        updateSic.add("initialAllocationRatio1");//ҵƽ̨ʼ
        updateSic.add("initialAllocationRatio2");//Ŀʼ
        updateSic.add("initialAllocationRatio3");//ֱĿ˳ʼ
    }

    /**
     * ģʱЯ
     *
     * @param columnInfoMap
     * @param wb
     * @param sheet
     */
    @Override
    public void completeGenerateExcel(Map<String, BaseColumnInfo> columnInfoMap,
                                      XSSFWorkbook wb,
                                      XSSFSheet sheet) {
        Context ctx = this.getContext();
        String parentId = this.getCustomParam("parentId");
        if (StringUtils.isEmpty(parentId)) {
            throw new RuntimeException("ҵĿݵģ屨,parentIdΪ!");
        }
        int beginRow = 4;//ɿʼ
        try {
            //
            IBonusCycle iBonusCycle = BonusCycleFactory.getLocalInstance(ctx);
            SelectorItemCollection sic = new SelectorItemCollection();
            sic.add("cycleName");
            sic.add("BusDepProject.*");
            sic.add("BusDepProject.busDep.name");//ҵ
            sic.add("BusDepProject.busDep.number");
            sic.add("BusDepProject.project.name");//Ŀ
            sic.add("BusDepProject.project.number");
            sic.add("BusDepProject.principal.name");//
            sic.add("BusDepProject.principal.number");
            BonusCycleInfo bonusCycleInfo = iBonusCycle.getBonusCycleInfo(new ObjectUuidPK(parentId), sic);
            String cycleName = bonusCycleInfo.getCycleName();//
            BonusCycleBusDepProjectCollection busDepProjectCols = bonusCycleInfo.getBusDepProject();//ҵĿ
            Map<Integer, String> columnIndexMap = this.getColumnIndexFn(columnInfoMap);
            int fillColumnCount = columnInfoMap.size();
            //صһ
            //sheet.setColumnHidden(0, true);
            for (int i = 0; i < busDepProjectCols.size(); i++) {
                Row row = sheet.createRow(i + beginRow);
                BonusCycleBusDepProjectInfo info = busDepProjectCols.get(i);
                for (int j = 0; j < fillColumnCount; ++j) {
                    String value = null;
                    Cell createCell = row.createCell(j);
                    String columnName = columnIndexMap.get(j);
                    int index = columnName.indexOf(".");
                    if (index == -1) {
                        Object obj = info.get(columnName);
                        if (obj != null) {
                            if (obj instanceof CoreBaseInfo) {
                                CoreBaseInfo coreBaseInfo = (CoreBaseInfo) info.get(columnName);
                                value = coreBaseInfo.get("number") + "##" + coreBaseInfo.get("name");
                            } else if (obj instanceof BigDecimal) {
                                BigDecimal bigDecimal = (BigDecimal) obj;
                                value = bigDecimal.setScale(2).toPlainString();
                            } else {
                                value = obj.toString();
                            }
                        }
                    } else {
                        value = cycleName;
                    }
                    createCell.setCellValue(value);
                }
            }
        } catch (BOSException var33) {
            if (var33.getMessage().contains("fetched too much rows")) {
                throw new ImportException("ѯƣϵϵͳԱ޸ã߼ص");
            } else {
                var33.printStackTrace();
                throw new ImportException("ģʧ", var33);
            }
        } catch (Exception var35) {
            var35.printStackTrace();
            throw new ImportException("ģʧ", var35);
        }
    }

    /**
     * ύ
     *
     * @param coreBaseInfo
     * @throws ImportException
     */
    @Override
    protected void submitData(CoreBaseInfo coreBaseInfo) throws ImportException {
        ImportException importException;
        try {
            IBonusCycleBusDepProject iBonusCycleBusDepProject = BonusCycleBusDepProjectFactory.getLocalInstance(this.getContext());
            iBonusCycleBusDepProject.updatePartial(coreBaseInfo, updateSic);
        } catch (EASBizException var4) {
            importException = new ImportException(var4.getMessage(this.getContext().getLocale()), var4);
            throw importException;
        } catch (BOSException var5) {
            importException = new ImportException(SHRServerResource.getString("com.kingdee.shr.base.syssetting.CommonserviceResource", "save_fails_bos", this.getContext()), var5);
            throw importException;
        } catch (Exception var6) {
            importException = new ImportException(SHRServerResource.getString("com.kingdee.shr.base.syssetting.CommonserviceResource", "save_submit_fails", this.getContext()), var6);
            throw importException;
        }
    }
    /**
     * жתMap
     *
     * @param columnInfoMap
     * @return
     */
    protected Map<Integer, String> getColumnIndexFn(Map<String, BaseColumnInfo> columnInfoMap) {
        Map<Integer, String> columnIndexMap = new HashMap();
        Iterator<String> keys = columnInfoMap.keySet().iterator();
        int var4 = 0;
        while (keys.hasNext()) {
            String key = keys.next();
            columnIndexMap.put(var4++, key);
        }
        return columnIndexMap;
    }

    /**
     * ȡַ
     *
     * @param row
     * @return
     */
    @Override
    protected String getPKSelectString(BaseRowInfo row) {
        List<BaseColumnInfo> keyColumnList = row.getKeyColumnInfo();
        for (int i = 0; i < keyColumnList.size(); ++i) {
            BaseColumnInfo keyColumn = keyColumnList.get(i);
            keyColumn.setCustomField(false);
        }
        return super.getPKSelectString(row);
    }
}
