package com.kingdee.eas.custom.projectbonus.web.service;

import com.kingdee.bos.Context;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.eas.basedata.org.AdminOrgUnitInfo;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.custom.projectbonus.*;
import com.kingdee.eas.custom.projectbonus.bizEnum.BusDepProjectStateEnum;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.util.app.ContextUtil;
import com.kingdee.shr.base.syssetting.app.io.fileImport.BaseColumnInfo;
import com.kingdee.shr.base.syssetting.app.io.fileImport.BaseImportService;
import com.kingdee.shr.base.syssetting.app.io.fileImport.BaseRowInfo;
import com.kingdee.shr.base.syssetting.app.io.fileImport.ImportException;
import com.kingdee.util.StringUtils;


/**
 * @Description Աϸбģ()_
 * @Date 2024/5/7 21:28
 * @Created by Heyuan
 */
public class PrincipalDetailImportServiceV2 extends BaseImportService {
    /**
     * ǰ÷
     *
     * @param coreBaseInfo
     * @throws ImportException
     */
//    @Override
//    protected void beforeSubmitData(CoreBaseInfo coreBaseInfo) throws ImportException {
//        super.beforeSubmitData(coreBaseInfo);
//        BonusCycleBusDepProjectAssPersonnelDetailInfo info = (BonusCycleBusDepProjectAssPersonnelDetailInfo) coreBaseInfo;
//        info.put("parent", parentId);
//    }

    /**
     * ȡַ
     *
     * @param row
     * @return
     */
    @Override
    protected String getPKSelectString(BaseRowInfo row) {
        String parentId = this.getCustomParam("parentId");
        String pkSelectString = super.getPKSelectString(row);
        StringBuilder pkString = new StringBuilder(pkSelectString);
        pkString.append(" and parent.parent.id ='").append(parentId).append("' ");
        String project = row.getValueOfString("BonusCycleBusDepProject.project");
        BaseColumnInfo columnInfo = row.getColumnInfo("BonusCycleBusDepProject.project");
        if (!StringUtils.isEmpty(project)) {
            CoreBaseInfo info = (CoreBaseInfo) row.getValueOfObjectByIndex(columnInfo.getColumnIndex());
            pkString.append(" and ").append(columnInfo.getPropName()).append(".id = '").append(info.getId().toString()).append("'");
        }else{
            pkString.append(" and ").append(columnInfo.getPropName()).append(".id is null");
        }
        return pkString.toString().replace("BonusCycleBusDepProject", "parent");
    }

    /**
     * ֶ
     *
     * @param baseInfo
     * @param row
     * @throws ImportException
     */
    protected void setOtherFieldInfo(CoreBaseInfo baseInfo, BaseRowInfo row) throws ImportException {
        try {
            Context ctx = this.getContext();
            BonusCycleBusDepProjectAssPersonnelDetailInfo info = (BonusCycleBusDepProjectAssPersonnelDetailInfo) baseInfo;
            String pkSelectString = getPKSelectString(row);
            FilterInfo oldFilterInfo = new FilterInfo(pkSelectString);
            FilterInfo filterInfo = new FilterInfo();
            FilterItemCollection filterItems = filterInfo.getFilterItems();
            FilterItemCollection oldFilterItems = oldFilterInfo.getFilterItems();
            for (int i = 0; i < oldFilterItems.size(); i++) {
                FilterItemInfo filterItemInfo = oldFilterItems.get(i);
                String propertyName = filterItemInfo.getPropertyName();
                if (propertyName.contains("parent.busDep.id")) {
                    filterItemInfo.setPropertyName("busDep.id");
                    filterItems.add(filterItemInfo);
                } else if (propertyName.contains("parent.parent.id")) {
                    filterItemInfo.setPropertyName("parent.id");
                    filterItems.add(filterItemInfo);
                } else if (propertyName.contains("parent.project.id")) {
                    filterItemInfo.setPropertyName("project.id");
                    filterItems.add(filterItemInfo);
                }
            }
            IBonusCycleBusDepProject iBonusCycleBusDepProject = BonusCycleBusDepProjectFactory.getLocalInstance(ctx);
            SelectorItemCollection sic = new SelectorItemCollection();
            sic.add("*");
            sic.add("busDep.name");
            sic.add("busDep.number");
            sic.add("project.name");
            sic.add("project.number");
            EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
            BonusCycleBusDepProjectCollection bonusCycleBusDepProjectCols = iBonusCycleBusDepProject.getBonusCycleBusDepProjectCollection(entityViewInfo);
            if (bonusCycleBusDepProjectCols.size() >= 0) {
                BonusCycleBusDepProjectInfo depProjectInfo = bonusCycleBusDepProjectCols.get(0);
                info.setParent(depProjectInfo);
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new ImportException(e.getMessage());
        }
    }

    /**
     * У
     *
     * @param coreBaseInfo
     * @throws ImportException
     */
    protected void verifyRowBiz(CoreBaseInfo coreBaseInfo) throws ImportException {
        BonusCycleBusDepProjectAssPersonnelDetailInfo info = (BonusCycleBusDepProjectAssPersonnelDetailInfo) coreBaseInfo;
        BonusCycleBusDepProjectInfo parent = info.getParent();
        if (parent == null) {
            throw new ImportException("ҵĿδҵ!");
        }
        //ҵ״̬
        BusDepProjectStateEnum state = parent.getState();
        //
        PersonInfo principal = parent.getPrincipal();
        StringBuilder errorMsg = new StringBuilder();
        AdminOrgUnitInfo project = parent.getProject();
        if (project != null) {
            String projectName = project.getName();
            errorMsg.append("Ŀ[").append(projectName);
        } else {
            String busDepName = parent.getBusDep().getName();
            errorMsg.append("ҵ[").append(busDepName);
        }
        if (!BusDepProjectStateEnum.ENABLE.equals(state)) {
            errorMsg.append("]״̬");
            throw new ImportException(errorMsg.toString());
        }
        Context ctx = this.getContext();
        //ǰ¼
        PersonInfo personInfo = ContextUtil.getCurrentUserInfo(ctx).getPerson();
        String personId = personInfo.getId().toString();
        if (!personId.equals(principal.getId().toString())) {
            errorMsg.append("]ĸ˲ǵǰˣ");
            throw new ImportException(errorMsg.toString());
        }
    }
}
